--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/lib/files.lib.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/lib/files.lib.php	2025-02-27 08:48:34.005874000 +0000
@@ -1983,7 +1983,7 @@
 				// Move file from temp directory to final directory. A .noexe may also be appended on file name.
 				$resupload = dol_move_uploaded_file($TFile['tmp_name'][$i], $destfull, $allowoverwrite, 0, $TFile['error'][$i], 0, $varfiles, $upload_dir);
 
-				if (is_numeric($resupload) && $resupload > 0) {   // $resupload can be 'ErrorFileAlreadyExists', 'ErrorFileIsInfectedWithAVirus...'
+				if (is_numeric($resupload) && $resupload > 0) {   // $resupload can be 'ErrorFileAlreadyExists'
 					include_once DOL_DOCUMENT_ROOT.'/core/lib/images.lib.php';
 
 					$tmparraysize = getDefaultImageSizes();
@@ -2047,7 +2047,7 @@
 						if (preg_match('/File is a PDF with javascript inside/', $resupload)) {
 							setEventMessages($langs->trans("ErrorFileIsAnInfectedPDFWithJSInside"), null, 'errors');
 						} else {
-							setEventMessages($langs->trans("ErrorFileIsInfectedWithAVirus").'<br>'.dolGetFirstLineOfText($resupload), null, 'errors');
+							setEventMessages($langs->trans("ErrorFileIsInfectedWithAVirus"), null, 'errors');
 						}
 					} else { // Known error
 						setEventMessages($langs->trans($resupload), null, 'errors');

########## core/lib/functions.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/lib/functions.lib.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/lib/functions.lib.php	2025-02-27 08:48:33.970350000 +0000
@@ -12566,7 +12566,7 @@
 	// TODO: add hook
 
 	// escape all attribute
-	$attr = array_map('dolPrintHtmlForAttribute', $attr);
+	$attr = array_map('dol_escape_htmltag', $attr);
 
 	$TCompiledAttr = array();
 	foreach ($attr as $key => $value) {

########## core/lib/pdf.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/lib/pdf.lib.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/lib/pdf.lib.php	2025-02-27 08:48:33.975878000 +0000
@@ -328,8 +328,7 @@
 }
 
 /**
- * Function to try to calculate height of a HTML Content.
- * WARNING: Do not use this function inside a TCPDF transaction.
+ * Function to try to calculate height of a HTML Content
  *
  * @param 	TCPDF     $pdf				PDF initialized object
  * @param 	string    $htmlcontent		HTML Content
@@ -340,9 +339,6 @@
 {
 	// store current object
 	$pdf->startTransaction();
-	// To avoid pagebreak effect or strange behavior of writeHTMLCell when we are out of page, we imagine we are at the begin of page to test the height of the text
-	// Another solution would be to do the test on another PDF instance with samefont, width...
-	$pdf->setY(0);
 	// store starting values
 	$start_y = $pdf->GetY();
 	//var_dump($start_y);
@@ -1216,7 +1212,7 @@
 	$pdf->SetDrawColor(224, 224, 224);
 	// Option for footer text color
 	if (getDolGlobalString('PDF_FOOTER_TEXT_COLOR')) {
-		list($r, $g, $b) = sscanf(getDolGlobalString('PDF_FOOTER_TEXT_COLOR'), '%d, %d, %d');
+		list($r, $g, $b) = sscanf($conf->global->PDF_FOOTER_TEXT_COLOR, '%d, %d, %d');
 		$pdf->SetTextColor($r, $g, $b);
 	}
 
@@ -1235,7 +1231,7 @@
 			$freetextheight = $pdf->getStringHeight($width, $line);
 		} else {
 			$freetextheight = pdfGetHeightForHtmlContent($pdf, dol_htmlentitiesbr($line, 1, 'UTF-8', 0)); // New method (works for HTML content)
-			//print '<br>'.$freetextheight;
+			//print '<br>'.$freetextheight;exit;
 		}
 	}
 
@@ -1457,8 +1453,6 @@
 		}
 		$parameters = array('pdf' => $pdf, 'i' => $i, 'outputlangs' => $outputlangs, 'w' => $w, 'h' => $h, 'posx' => $posx, 'posy' => $posy, 'hideref' => $hideref, 'hidedesc' => $hidedesc, 'issupplierline' => $issupplierline, 'special_code' => $special_code);
 		$action = '';
-		// WARNING: A hook must not close/open the PDF transaction. Doing this generates a lot of trouble.
-		// Test to know if content added by the hooks is already done by the main caller of pdf_writelinedesc
 		$reshook = $hookmanager->executeHooks('pdf_writelinedesc', $parameters, $object, $action); // Note that $action and $object may have been modified by some hooks
 
 		if (!empty($hookmanager->resPrint)) {

########## core/lib/website.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/lib/website.lib.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/lib/website.lib.php	2025-02-27 08:48:34.038607000 +0000
@@ -286,12 +286,12 @@
 	global $db, $langs, $conf, $user;
 	global $dolibarr_main_url_root, $dolibarr_main_data_root;
 	global $website;
-	global $includehtmlcontentopened;	// $includehtmlcontentopened is the level of includes (start at 0 for main page, 1 for first level include, ...)
+	global $includehtmlcontentopened;
 	'@phan-var-force Website $website';
 
 	$nbrep = 0;
 
-	dol_syslog("dolWebsiteOutput start - contenttype=".$contenttype." containerid=".$containerid.(defined('USEDOLIBARREDITOR') ? ' USEDOLIBARREDITOR=1' : '').(defined('USEDOLIBARRSERVER') ? ' USEDOLIBARRSERVER=1' : '').' includehtmlcontentopened='.$includehtmlcontentopened);
+	dol_syslog("dolWebsiteOutput start - contenttype=".$contenttype." containerid=".$containerid." USEDOLIBARREDITOR=".(defined('USEDOLIBARREDITOR') ? '1' : '')." USEDOLIBARRSERVER=".(defined('USEDOLIBARRSERVER') ? '1' : '').' includehtmlcontentopened='.$includehtmlcontentopened);
 
 	//print $containerid.' '.$content;
 
@@ -558,7 +558,7 @@
 			unset($tmpwebsitepage);
 		}
 		if ($result > 0) {
-			$currenturi = $_SERVER["REQUEST_URI"];	// Example: /public/website/index.php?website=mywebsite.com&pageref=mywebsite-home&cache=3600
+			$currenturi = $_SERVER["REQUEST_URI"];	// Example: /public/website/index.php?website=mywebsite.com&pageref=mywebsite-home&nocache=1708177483
 			$regtmp = array();
 			if (preg_match('/&pageref=([^&]+)/', $currenturi, $regtmp)) {
 				if ($regtmp[0] == $containerref) {
@@ -1573,15 +1573,9 @@
 					dol_mkdir(dirname($filetosave));
 
 					$fp = fopen($filetosave, "w");
-					if ($fp) {
-						fwrite($fp, $tmpgeturl['content']);
-						fclose($fp);
-						dolChmod($filetosave);
-					} else {
-						$error++;
-						setEventMessages('Error failed to open file '.$filetosave.' for writing', null, 'errors');
-						$action = 'create';
-					}
+					fwrite($fp, $tmpgeturl['content']);
+					fclose($fp);
+					dolChmod($filetosave);
 				}
 			}
 		}

########## core/lib/website2.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/lib/website2.lib.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/lib/website2.lib.php	2025-02-27 08:48:33.946616000 +0000
@@ -183,9 +183,6 @@
 		$tplcontent .= "} // Not already loaded\n";
 		$tplcontent .= "require_once DOL_DOCUMENT_ROOT.'/core/lib/website.lib.php';\n";
 		$tplcontent .= "require_once DOL_DOCUMENT_ROOT.'/core/website.inc.php';\n";
-		if (in_array($objectpage->type_container, array('page', 'blogpost', 'service'))) {
-			$tplcontent .= 'dol_syslog("--- Prepare content of page '.((int) $objectpage->id).' - '.$objectpage->pageurl.'");'."\n";
-		}
 		$tplcontent .= "ob_start();\n";
 		$tplcontent .= "// END PHP ?>\n";
 		if (getDolGlobalString('WEBSITE_FORCE_DOCTYPE_HTML5')) {
@@ -373,9 +370,6 @@
 		$tplcontent .= "} // Not already loaded\n";
 		$tplcontent .= "require_once DOL_DOCUMENT_ROOT.'/core/lib/website.lib.php';\n";
 		$tplcontent .= "require_once DOL_DOCUMENT_ROOT.'/core/website.inc.php';\n";
-		if (in_array($objectpage->type_container, array('page', 'blogpost', 'service'))) {
-			$tplcontent .= 'dol_syslog("--- Prepare content of page '.((int) $objectpage->id).' - '.$objectpage->pageurl.'");'."\n";
-		}
 		$tplcontent .= "// END PHP ?>\n";
 
 		$tplcontent .= $objectpage->content;

########## core/modules/facture/doc/pdf_crabe.modules.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/modules/facture/doc/pdf_crabe.modules.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/modules/facture/doc/pdf_crabe.modules.php	2025-02-27 08:48:34.781830000 +0000
@@ -831,7 +831,7 @@
 						} else {
 							$this->_tableau($pdf, $tab_top_newpage, $this->page_hauteur - $tab_top_newpage - $heightforfooter, 0, $outputlangs, 1, 1, $object->multicurrency_code);
 						}
-						$this->_pagefoot($pdf, $object, $outputlangs, 1, $this->getHeightForQRInvoice($pagenb, $object, $outputlangs));
+						$this->_pagefoot($pdf, $object, $outputlangs, 1, $this->getHeightForQRInvoice($pagenb, $object, $langs));
 						$pagenb++;
 						$pdf->setPage($pagenb);
 						$pdf->setPageOrientation('', 1, 0); // The only function to edit the bottom margin of current page to set it.
@@ -849,7 +849,7 @@
 						} else {
 							$this->_tableau($pdf, $tab_top_newpage, $this->page_hauteur - $tab_top_newpage - $heightforfooter, 0, $outputlangs, 1, 1, $object->multicurrency_code);
 						}
-						$this->_pagefoot($pdf, $object, $outputlangs, 1, $this->getHeightForQRInvoice($pagenb, $object, $outputlangs));
+						$this->_pagefoot($pdf, $object, $outputlangs, 1, $this->getHeightForQRInvoice($pagenb, $object, $langs));
 						// New page
 						$pdf->AddPage();
 						if (!empty($tplidx)) {
@@ -1359,7 +1359,6 @@
 
 					$langs->loadLangs(array('payment', 'paybox', 'stripe'));
 					$servicename = $langs->transnoentities('Online');
-
 					$paiement_url = getOnlinePaymentUrl(0, 'invoice', $object->ref, 0, '', 0);
 					$linktopay = $langs->trans("ToOfferALinkForOnlinePayment", $servicename).' <a href="'.$paiement_url.'">'.$outputlangs->transnoentities("ClickHere").'</a>';
 

########## core/modules/facture/doc/pdf_sponge.modules.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/modules/facture/doc/pdf_sponge.modules.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/modules/facture/doc/pdf_sponge.modules.php	2025-02-27 08:48:34.784401000 +0000
@@ -343,7 +343,7 @@
 				$this->heightforfreetext = getDolGlobalInt('MAIN_PDF_FREETEXT_HEIGHT', 5); // Height reserved to output the free text on last page
 				$this->heightforfooter = $this->marge_basse + (!getDolGlobalString('MAIN_GENERATE_DOCUMENTS_SHOW_FOOT_DETAILS') ? 12 : 22); // Height reserved to output the footer (value include bottom margin)
 
-				$heightforqrinvoice = 0;
+				$heightforqrinvoice = $heightforqrinvoice_firstpage = 0;
 				if (getDolGlobalString('INVOICE_ADD_SWISS_QR_CODE') == 'bottom') {
 					if ($this->getHeightForQRInvoice(1, $object, $langs) > 0) {
 						// Shrink infotot to a base 30

########## core/modules/member/mod_member_simple.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/modules/member/mod_member_simple.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/modules/member/mod_member_simple.php	2025-02-27 08:48:34.734852000 +0000
@@ -92,7 +92,6 @@
 		$sql = "SELECT MAX(CAST(ref AS SIGNED)) as max";
 		$sql .= " FROM ".MAIN_DB_PREFIX."adherent";
 		$sql .= " WHERE entity = ".$conf->entity;
-
 		$resql = $db->query($sql);
 		if ($resql) {
 			$row = $db->fetch_row($resql);
@@ -126,7 +125,6 @@
 		$sql = "SELECT MAX(CAST(ref AS SIGNED)) as max";
 		$sql .= " FROM ".MAIN_DB_PREFIX."adherent";
 		$sql .= " WHERE entity = ".(int) $conf->entity;
-		$sql .= " AND ref <> '(PROV)'";
 
 		$resql = $db->query($sql);
 		if ($resql) {

########## core/modules/supplier_order/doc/pdf_cornas.modules.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/modules/supplier_order/doc/pdf_cornas.modules.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/modules/supplier_order/doc/pdf_cornas.modules.php	2025-02-27 08:48:34.571270000 +0000
@@ -794,9 +794,9 @@
 
 				// Show square
 				if ($pagenb == $pageposbeforeprintlines) {
-					$this->_tableau($pdf, $tab_top, $this->page_hauteur - $tab_top - $heightforinfotot - $heightforfreetext - $heightforfooter, 0, $outputlangs, $hidetop, 0, $object->multicurrency_code);
+					$this->_tableau($pdf, $tab_top, $this->page_hauteur - $tab_top - $heightforinfotot - $heightforfreetext - $heightforfooter, 0, $outputlangs, $hidetop, 0, $object->multicurrency_code, $outputlangsbis);
 				} else {
-					$this->_tableau($pdf, $tab_top_newpage, $this->page_hauteur - $tab_top_newpage - $heightforinfotot - $heightforfreetext - $heightforfooter, 0, $outputlangs, 1, 0, $object->multicurrency_code);
+					$this->_tableau($pdf, $tab_top_newpage, $this->page_hauteur - $tab_top_newpage - $heightforinfotot - $heightforfreetext - $heightforfooter, 0, $outputlangs, 1, 0, $object->multicurrency_code, $outputlangsbis);
 				}
 				$bottomlasttab = $this->page_hauteur - $heightforinfotot - $heightforfreetext - $heightforfooter + 1;
 

########## core/triggers/interface_50_modTicket_TicketEmail.class.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/core/triggers/interface_50_modTicket_TicketEmail.class.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/core/triggers/interface_50_modTicket_TicketEmail.class.php	2025-02-27 08:48:34.055151000 +0000
@@ -1,10 +1,10 @@
 <?php
-/* Copyright (C) 2014-2016  Jean-François Ferry	<hello@librethic.io>
+/*
+ * Copyright (C) 2014-2016  Jean-François Ferry	<hello@librethic.io>
+ * 				 2016       Christophe Battarel <christophe@altairis.fr>
  * Copyright (C) 2023		Benjamin Falière	<benjamin.faliere@altairis.fr>
- * Copyright (C) 2025       Frédéric France     <frederic.france@free.fr>
- * Copyright (C) 2024		MDW	                <mdeweerd@users.noreply.github.com>
- * Copyright (C) 2016       Christophe Battarel <christophe@altairis.fr>
- * Copyright (C) 2023-2025	Benjamin Falière	<benjamin@faliere.com>
+ * Copyright (C) 2024		MDW							<mdeweerd@users.noreply.github.com>
+ * Copyright (C) 2025       Frédéric France         <frederic.france@free.fr>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -472,13 +472,10 @@
 		}
 		$message_customer .= '<p>'.$langs->trans('Message').' : <br><br>'.$message.'</p><br>';
 
-		if (getDolGlobalInt('TICKET_ENABLE_PUBLIC_INTERFACE')) {
-			$url_public_ticket = getDolGlobalString('TICKET_URL_PUBLIC_INTERFACE', dol_buildpath('/public/ticket/', 2)).'view.php?track_id='.((int) $object->track_id);
-			$message_customer .= '<p>'.$langs->trans($see_ticket).' : <a href="'.$url_public_ticket.'">'.$url_public_ticket.'</a></p>';
-			$message_customer .= '<p>'.$langs->trans('TicketEmailPleaseDoNotReplyToThisEmail').'</p>';
-		} else {
-			$message_customer .= '<p>'.$langs->trans('TicketEmailPleaseDoNotReplyToThisEmailNoInterface').'</p>';
-		}
+		$url_public_ticket = getDolGlobalString('TICKET_URL_PUBLIC_INTERFACE', dol_buildpath('/public/ticket/', 2)).'view.php?track_id='.$object->track_id;
+
+		$message_customer .= '<p>'.$langs->trans($see_ticket).' : <a href="'.$url_public_ticket.'">'.$url_public_ticket.'</a></p>';
+		$message_customer .= '<p>'.$langs->trans('TicketEmailPleaseDoNotReplyToThisEmail').'</p>';
 
 		$from = (getDolGlobalString('MAIN_INFO_SOCIETE_NOM') ? getDolGlobalString('MAIN_INFO_SOCIETE_NOM') . ' ' : '').'<' . getDolGlobalString('TICKET_NOTIFICATION_EMAIL_FROM').'>';
 

########## debugbar/class/TraceableDB.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/debugbar/class/TraceableDB.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/debugbar/class/TraceableDB.php	2025-02-27 08:48:40.706741000 +0000
@@ -86,19 +86,6 @@
 		return $this->db->ifsql($test, $resok, $resko);
 	}
 
-	/**
-	 *	format a sql regexp
-	 *
-	 *	@param	string	$subject        field name to test
-	 *	@param	string  $pattern        sql pattern to match
-	 *	@param	int		$sqlstring      0=the string being tested is a hard coded string, 1=the string is a field
-	 *	@return	string          		sql string
-	 */
-	public function regexpsql($subject, $pattern, $sqlstring = 0): string
-	{
-		return $this->db->regexpsql($subject, $pattern, $sqlstring = 0);
-	}
-
 	// phpcs:disable PEAR.NamingConventions.ValidFunctionName.ScopeNotCamelCaps
 	/**
 	 * Return datas as an array

########## ecm/class/ecmfiles.class.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/ecm/class/ecmfiles.class.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/ecm/class/ecmfiles.class.php	2025-02-27 08:48:40.712253000 +0000
@@ -1009,9 +1009,9 @@
 
 		if ($option) {
 			if ($option == 'facture_fournisseur') {
-				$tmppath = preg_replace('/^(\d+\/)?fournisseur\/facture\//', '', $this->filepath);
+				$tmppath = preg_replace('/^fournisseur\/facture\//', '', $this->filepath);
 			} elseif ($option == 'commande_fournisseur') {
-				$tmppath = preg_replace('/^(\d+\/)?fournisseur\/commande\//', '', $this->filepath);
+				$tmppath = preg_replace('/^fournisseur\/commande\//', '', $this->filepath);
 			} else {
 				if ((int) $this->entity > 1) {
 					// Remove the part "entityid/commande/" into "entityid/commande/REFXXX" to get only the ref

########## expensereport/card.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/expensereport/card.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/expensereport/card.php	2025-02-27 08:48:35.513528000 +0000
@@ -473,15 +473,10 @@
 						setEventMessages($mesg, null, 'mesgs');
 					} else {
 						$langs->load("other");
-						if (!empty($mailfile->error) || !empty($mailfile->errors)) {
+						if ($mailfile->error) {
 							$mesg = '';
-							$mesg .= $langs->transnoentities('ErrorFailedToSendMail', dol_escape_htmltag($emailFrom), dol_escape_htmltag($emailTo));
-							if (!empty($mailfile->error)) {
-								$mesg .= '<br>' . $mailfile->error;
-							}
-							if (!empty($mailfile->errors) && is_array($mailfile->errors)) {
-								$mesg .= '<br>' . implode('<br>', $mailfile->errors);
-							}
+							$mesg .= $langs->trans('ErrorFailedToSendMail', $emailFrom, $emailTo);
+							$mesg .= '<br>'.$mailfile->error;
 							setEventMessages($mesg, null, 'errors');
 						} else {
 							setEventMessages('No mail sent. Feature is disabled by option MAIN_DISABLE_ALL_MAILS', null, 'warnings');
@@ -2610,12 +2605,12 @@
 
 				// Select VAT
 				print '<td class="right inputvat">';
-				$defaultvat = '';
+				$defaultvat = -1;
 				if (getDolGlobalString('EXPENSEREPORT_NO_DEFAULT_VAT')) {
 					// If option to have no default VAT on expense report is on, we force MAIN_VAT_DEFAULT_IF_AUTODETECT_FAILS
 					$conf->global->MAIN_VAT_DEFAULT_IF_AUTODETECT_FAILS = 'none';
 				}
-				print $form->load_tva('vatrate', (!empty($vatrate) ? $vatrate : $defaultvat), null, null, 0, 0, '', false, 1);
+				print $form->load_tva('vatrate', (!empty($vatrate) ? $vatrate : $defaultvat), $mysoc, '', 0, 0, '', false, 1);
 				print '</td>';
 
 				// Unit price net

########## fourn/facture/list.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/fourn/facture/list.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/fourn/facture/list.php	2025-05-02 15:10:17.929129000 +0000
@@ -783,19 +783,36 @@
 $nbtotalofrecords = '';
 if (!getDolGlobalInt('MAIN_DISABLE_FULL_SCANLIST')) {
 	/* The fast and low memory method to get and count full list converts the sql into a sql count */
-	$sqlforcount = preg_replace('/^'.preg_quote($sqlfields, '/').'/', 'SELECT COUNT(*) as nbtotalofrecords', $sql);
-	$sqlforcount = preg_replace('/GROUP BY .*$/', '', $sqlforcount);
-	$sqlforcount = preg_replace('/LEFT JOIN '.MAIN_DB_PREFIX.'paiementfourn_facturefourn as pf ON pf.fk_facturefourn = f.rowid/', '', $sqlforcount);
+	$parameters = array(
+		'sqlforcount' => $sql,
+		'sqlfields' => $sqlfields,
+		'context' => $parameters['context']
+	);
+
+	//MODIF JOSE
+	$reshook = $hookmanager->executeHooks('beforeCountQuery', $parameters, $object, $action);
+
+	if ($reshook > 0 && !empty($hookmanager->resPrint)) {
+		$sqlforcount = $hookmanager->resPrint;
+	} else {
+		$sqlforcount = preg_replace('/^' . preg_quote($sqlfields, '/') . '/', 'SELECT COUNT(*) as nbtotalofrecords', $sql);
+		$sqlforcount = preg_replace('/GROUP BY .*$/', '', $sqlforcount);
+	}
 
 	$resql = $db->query($sqlforcount);
 	if ($resql) {
 		$objforcount = $db->fetch_object($resql);
 		$nbtotalofrecords = $objforcount->nbtotalofrecords;
+
+		$_GET['total_ht'] = $objforcount->total_ht ?? 0;
+		$_GET['total_tva'] = $objforcount->total_tva ?? 0;
+		$_GET['total_ttc'] = $objforcount->total_ttc ?? 0;
+
 	} else {
 		dol_print_error($db);
 	}
 
-	if (($page * $limit) > $nbtotalofrecords) {	// if total resultset is smaller than the paging size (filtering), goto and load page 0
+	if (($page * $limit) > $nbtotalofrecords) {	// if total resultset is smaller than paging size (filtering), goto and load page 0
 		$page = 0;
 		$offset = 0;
 	}

########## main.inc.php
